/*****************************************************************************
 *	aisa29w.c									
 *												
 *	aISA-M29								
 *												
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.		
 *												
 *	Date 1998/05/20								
 *												
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa29w.h"	// aISA-M29

//---------- X^eBbN֐ & X^eBbNϐ(萔)  ----------------------
static BOOL Aisa29wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa29GetVersion;
static FARPROC pAisa29Create;
static FARPROC pAisa29Close;
static FARPROC pAisa29GetResource;
static FARPROC pAisa29ModeSet;
static FARPROC pAisa29CreqWrite;
static FARPROC pAisa29GetStatus;
static FARPROC pAisa29DataWrite;
static FARPROC pAisa29DataRead;
static FARPROC pAisa29CascadeWrite;
static FARPROC pAisa29CascadeRead;
static FARPROC pAisa29GetLastError;

BOOL Aisa29wDllOpen ( void )
/*****************************************************************************
 * @\  aisa29.dll[h
 *   Ȃ
 * ߒl  TRUE  --- 
 *       FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA29_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa29wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa29wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa29wDllClose ( void )
/*****************************************************************************
 * @\  aisa29.dllA[h
 *   Ȃ
 * ߒl  TRUE  --- 
 *       FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa29wGetVersion ( PDWORD pdwDllVersion, PDWORD pdwDrvVersion )
/*****************************************************************************
 * @\  aISA-M29̃o[Wԍ擾
 *   pdwDllVersion --- DLLo[Wԍi[AhX
 *       pdwDrvVersion --- DRVo[Wԍi[AhX
 * ߒl  TRUE          --- 
 *       FALSE         --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29GetVersion)(pdwDllVersion, pdwDrvVersion);
}

BOOL Aisa29wCreate( PWORD pwLogSlot)
/*****************************************************************************
 * @\  aISA-M29̔Cӂ̃foCX̎gp錾
 *   pwLogSlot  --- gpfoCXi[AhX
 * ߒl  TRUE       --- 
 *       FALSE      --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29Create)(pwLogSlot);
}

BOOL Aisa29wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-M29̔Cӂ̃foCX̎gpJ
 *   wLogSlot  --- gpfoCX
 * ߒl  TRUE      --- 
 *       FALSE     --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29Close)(wLogSlot);
}

BOOL Aisa29wGetResource ( WORD wLogSlot, PAISA29R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 *   wLogSlot --- ׂfoCX
 *       pResInfo --- \[Xi[\̂̃AhX
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa29wModeSet( WORD wLogSlot, BYTE bMode )
/*****************************************************************************
 * @\  [hZbg
 *   wLogSlot --- ݒ肷foCX
 *       bMode    --- [h
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29ModeSet)(wLogSlot, bMode);
}

BOOL Aisa29wCreqWrite( WORD wLogSlot, WORD wCreq )
/*****************************************************************************
 * @\  C-REQ |[g֏
 *   wLogSlot --- ݂foCX
 *       wCreq    --- C-REQ `l ( AISA29_CREQ_1 ܂ AISA29_CREQ_2 )
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29CreqWrite)(wLogSlot, wCreq);
}

BOOL Aisa29wGetStatus( WORD wLogSlot, PBYTE pbStatus )
/*****************************************************************************
 * @\  Xe[^Xǂݍ
 *   wLogSlot --- ǂݍ݂foCX
 *       wCreq    --- Xe[^Xi[̈ւ̃|C^
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29GetStatus)(wLogSlot, pbStatus);
}

BOOL Aisa29wDataWrite( WORD wLogSlot, BYTE bCmd, DWORD dwData )
/*****************************************************************************
 * @\  f[^
 *   wLogSlot --- ݂foCX
 *       bCmd     --- R}h
 *       dwData   --- f[^
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29DataWrite)(wLogSlot, bCmd, dwData);
}

BOOL Aisa29wDataRead( WORD wLogSlot, BYTE bCmd, PDWORD pdwData )
/*****************************************************************************
 * @\  f[^ǂݍ
 *   wLogSlot --- ǂݍ݂foCX
 *       bCmd     --- R}h
 *       dwData   --- f[^i[̈ւ̃|C^
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29DataRead)(wLogSlot, bCmd, pdwData);
}

BOOL Aisa29wCascadeWrite( WORD wLogSlot, DWORD dwCh1Data, DWORD dwCh2Data )
/*****************************************************************************
 * @\  JXP[h
 *   wLogSlot --- ݂foCX
 *       dwCh1Data--- `lPɏރf[^
 *       dwCh2Data--- `lQɏރf[^
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29CascadeWrite)(wLogSlot, dwCh1Data, dwCh2Data);
}

BOOL Aisa29wCascadeRead( WORD wLogSlot, PDWORD pdwCh1Data, PDWORD pdwCh2Data )
/*****************************************************************************
 * @\  JXP[hǂݍ
 *   wLogSlot --- ǂݍ݂foCX
 *       dwCh1Data--- `lPf[^i[̈ւ̃|C^
 *       dwCh2Data--- `lQf[^i[̈ւ̃|C^
 * ߒl  TRUE     --- 
 *       FALSE    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa29CascadeRead)(wLogSlot, pdwCh1Data, pdwCh2Data);
}

DWORD Aisa29wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-M29̃G[R[h
 *   wLogSlot  --- G[foCX
 * ߒl  TRUE      --- 
 *       FALSE     --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA29_ERR_WRAPDLL;
	}
	return (*pAisa29GetLastError)(wLogSlot);
}

static BOOL Aisa29wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 *   DLLGNX|[g֐AhX̎擾	
 *   Ȃ
 * ߒl  TRUE      --- 
 *       FALSE     --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa29GetVersion ̃AhX擾
	pAisa29GetVersion = GetProcAddress(hDLL, _T("Aisa29GetVersion"));
	if (pAisa29GetVersion == NULL) return FALSE;
	
	// Aisa29Create ̃AhX擾
	pAisa29Create = GetProcAddress(hDLL, _T("Aisa29Create"));
	if (pAisa29Create == NULL) return FALSE;
	
	// Aisa29lose ̃AhX擾
	pAisa29Close = GetProcAddress(hDLL, _T("Aisa29Close"));
	if (pAisa29Close == NULL) return FALSE;

	// Aisa29GetResource ̃AhX擾
	pAisa29GetResource = GetProcAddress(hDLL, _T("Aisa29GetResource"));
	if (pAisa29GetResource == NULL) return FALSE;

	// Aisa29ModeSet ̃AhX擾
	pAisa29ModeSet = GetProcAddress(hDLL, _T("Aisa29ModeSet"));
	if (pAisa29ModeSet == NULL ) return FALSE;

	// Aisa29CreqWrite ̃AhX擾
	pAisa29CreqWrite = GetProcAddress(hDLL, _T("Aisa29CreqWrite"));
	if (pAisa29CreqWrite == NULL ) return FALSE;

	// Aisa29GetStatus ̃AhX擾
	pAisa29GetStatus = GetProcAddress(hDLL, _T("Aisa29GetStatus"));
	if (pAisa29GetStatus == NULL ) return FALSE;

	// Aisa29DataWrite ̃AhX擾
	pAisa29DataWrite = GetProcAddress(hDLL, _T("Aisa29DataWrite"));
	if (pAisa29DataWrite == NULL ) return FALSE;

	// Aisa29DataRead ̃AhX擾
	pAisa29DataRead = GetProcAddress(hDLL, _T("Aisa29DataRead"));
	if (pAisa29DataRead == NULL ) return FALSE;

	// Aisa29CascadeWrite ̃AhX擾
	pAisa29CascadeWrite = GetProcAddress(hDLL, _T("Aisa29CascadeWrite"));
	if (pAisa29CascadeWrite == NULL ) return FALSE;

	// Aisa29CascadeRead ̃AhX擾
	pAisa29CascadeRead = GetProcAddress(hDLL, _T("Aisa29CascadeRead"));
	if (pAisa29CascadeRead == NULL ) return FALSE;

	// Aisa29GetLastError ̃AhX擾
	pAisa29GetLastError = GetProcAddress(hDLL, _T("Aisa29GetLastError"));
	if (pAisa29GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
